{ (C) 2001 Marek Wodzinski
 This code is licensed under GNU GPL
 File version: 1.1
 Last modification: Thu Aug 23 19:53:11 2001

 Changes:
 1.0 -> 1.1: reverse dumping order to 'natural'
}

uses rex;

var
  db,i:word;
  k:integer;

procedure dump_field(buf:twbufor;chars:longint);
var
  i:longint;
begin
  for i:=0 to chars-1 do
    if (buf^[i]<32) or (buf^[i]>127) then write('\x',hexstr(buf^[i],2))
      else write(chr(buf^[i]));
end;

procedure dump_database(db:word);
var
  page,len:word;
  dbtypes,tt:twdbtype;
  dbrecords,rr,ee:twdbrecord;
  pom:tdbrecord;
  index:integer;
begin
  writeln(stderr,'find...');
  find_db(db,dbtypes,page);
  writeln(stderr,'read...');
  read_db(page,dbrecords);
  
  writeln(stderr,'dumping...');
  
  writeln('ApplicationName:Etc_Data');
  writeln('DBID:',db);
  tt:=dbtypes;
  while tt<>nil do
  begin
    write(fieldtostr(tt^.typ));
    if tt^.next<>nil then write(#9);
    tt:=tt^.next;
  end;
  writeln;

  //reversing list order
  ee:=dbrecords;
  rr:=nil;
  while ee<>nil do
  begin
    pom.next:=rr;
    pom.size:=ee^.size;
    pom.data:=ee^.data;
    new(rr);
    rr^:=pom;
    pom.next:=ee;
    ee:=ee^.next;
    dispose(pom.next);
  end;
  
  dbrecords:=rr;
  while rr<>nil do
  begin
    tt:=dbtypes;
    index:=0;
    while tt<>nil do
    begin
      case tt^.typ of
	    1: begin  //DB_INT8(01)
		 write(byte(rr^.data^[index]));
		 inc(index);
	       end;
	    2: begin  //DB_INT16(02)
		 write(word(rr^.data^[index]+256*rr^.data^[index+1]));
		 inc(index,2);
	       end;
	    3: begin  //DB_INT32(03)
		 write(cardinal(rr^.data^[index]+256*rr^.data^[index+1]+65536*rr^.data^[index+2]+16777216*rr^.data^[index+3]));
		 inc(index,4);
	       end;
	    11: begin  //DB_FXDSTR(0B)
		  index:=index+tt^.size;
		  //write('fxstr(',tt^.size,')...');
		  dump_field(rr^.data,tt^.size);
		end;
	    12: begin  //DB_FXDDAT(0C)
		  index:=index+tt^.size;
		  //write('fxdat(',tt^.size,')...');
		  dump_field(rr^.data,tt^.size);
		end;
	    21: begin  //DB_VARSTR(15)
		  len:=rr^.data^[index]+256*rr^.data^[index+1];
		  dump_field(@rr^.data^[index+2],len);
		  index:=index+2+len;
		end;
	    22: begin  //DB_VARDAT(16)
		  len:=rr^.data^[index]+256*rr^.data^[index+1];
		  dump_field(@rr^.data^[index+2],len);
		  index:=index+2+len;
		  //write('vardat(',len,')...');
		end;
	    90: begin  //DB_RECID(5A)
		  write(cardinal(rr^.data^[index]+256*rr^.data^[index+1]+65536*rr^.data^[index+2]+16777216*rr^.data^[index+3]));
		  inc(index,4);
		end;
      end;
      if tt^.next<>nil then write(#9);
      tt:=tt^.next;
    end;
    writeln;
    rr:=rr^.next;
  end;
  //readln;
  writeln(stderr,'destroy db...');
  destroy_db_records(dbrecords);
  writeln(stderr,'destroy types...');
  destroy_db_type(dbtypes);
end;

begin
  if paramcount<2 then
  begin
    writeln(stderr,'Usage: rexdbdump device db_id [db_id]...');
    writeln(stderr,'Messages are sent to stderr, database content to stdout');
    halt(1);
  end;
  if not open_rex(paramstr(1)) then halt(1);
  for i:=2 to paramcount do
  begin
    val(paramstr(i),db,k);
    if k>0 then
      writeln(stderr,'Invalid parameter: ',paramstr(i)) else
      dump_database(db);
  end;
  close_rex;
end.